#! /usr/bin/env python3
import time
import rospy
from geometry_msgs.msg import Twist
from std_msgs.msg import Bool
from geometry_msgs.msg import PoseStamped

time = [ 0.0, 0.0 ]
cmd_vel = [ 0.0, 0.0 ]
flg = [ False, False ]
status = False
goalinfo = False

def measureTime():
    global cmd_vel, time, flg, status
    
    if not(flg[0]) and (cmd_vel[0] != 0.0 or cmd_vel[1] != 0.0):
       time[0] = rospy.Time.now().to_sec()
       flg[0] = True
       rospy.loginfo("start time: " + str(time[0]))
       
    if (status or not(goalinfo)) and (flg[0] and not(flg[1])) and (cmd_vel[0] == 0.0 and cmd_vel[1] == 0.0):
        time[1] = rospy.Time.now().to_sec()
        flg[1] = True
        rospy.loginfo("end time: " + str(time[1]))
    
    if flg[0] and flg[1]:
        rospy.loginfo("measure the time: " + str(time[1] - time[0]))
        flg[0] = False
        flg[1] = False
        status = False
#     rospy.loginfo("time: " + str(time.time()))

def cmdvelCallback(msg):
    global cmd_vel
    cmd_vel[0] = msg.linear.x
    cmd_vel[1] = msg.angular.z
#     rospy.loginfo(msg)
#     rospy.loginfo(str(msg.linear.x) + " " + str(msg.linear.y) + " " + str(msg.linear.z))
#     rospy.loginfo(str(msg.angular.x) + " " + str(msg.angular.y) + " " + str(msg.angular.z))
#     rospy.loginfo(str(cmd_vel[0]) + " " + str(cmd_vel[1]))

def goalstatusCallback(msg):
    global status
    if msg.data:
        status = msg.data

def goalCallback(msg):
    global goalinfo
    goalinfo = True

if __name__ == '__main__':
    try:
        rospy.init_node("measureTime", anonymous=True)
        rospy.Subscriber("/tb3_01/cmd_vel", Twist, cmdvelCallback)
        rospy.Subscriber("/tb3_01/goal_status", Bool, goalstatusCallback)
        rospy.Subscriber("/tb3_01/move_base_simple/goal", PoseStamped, goalCallback)
        
        rate = rospy.Rate(20)
        
        while not rospy.is_shutdown():
            measureTime()
#             rospy.spin()
            rate.sleep()
            
    except rospy.ROSInterruptException:
        pass
